function v = interval2vert(bounds)
% v = interval2vert(bounds)
% The first column of bounds consists of the minimum value in every
% direction and the second column the maximum value in every direction. The
% output v is 2^n by n where n is the dimension.
% 
% Rik Koch (TU Delft, 2021)

n = size(bounds,1);
xmin = bounds(:,1);
xmax = bounds(:,2);
v = zeros(2^n,n);
A = zeros(2^n,n);
for i = 1:2^n
    A(i,:) = de2bi(i-1,n);
end
for i = 1:n
    v(:,i) = A(:,i).*xmax(i) + (ones(2^n,1) - A(:,i)).*xmin(i); 
end
end