function [c,ceq] = nonlconsqp(u,sqp,varargin)
% constraints of the nonlinear programming problem in order to solve it
% using sqp
% 
% Rik Koch (TU Delft, 2021)

ceq = [];
p = size(sqp.setX.A,2);
q = size(sqp.setU.um,1);
inx = 0;
if (nargin > 2 && ~isempty(varargin{1}))
    yalmipsol = varargin{1};
else
    yalmipsol = 0;
end
if (yalmipsol == 1)
    if (nargin > 3 && ~isempty(varargin{2}))
        x = varargin{2};
        inx = 1;
    else
        x = sdpvar(sqp.n,sqp.Nc);
    end
    c = sdpvar(p*sqp.n + q*sqp.m,1);
else
    x = zeros(sqp.n,sqp.Nc);
    c = zeros(p*sqp.n + q*sqp.m,1);
end
for k = 1:sqp.Nc
    if (inx == 0)
        if (k > 1)
            x(:,k) = sqp.modelfun(x(:,k-1),u((k-1)*sqp.m+1:k*sqp.m));
        else
            x(:,k) = sqp.modelfun(sqp.x0,u((k-1)*sqp.m+1:k*sqp.m));
        end
    end
    c((k-1)*(p+q)+1:k*(p+q)-q) = sqp.setX.A'*x(:,k) - ones(p,1);
    c(k*(p+q)-q+1:k*(p+q)) = sqp.setU.M*u((k-1)*sqp.m+1:k*sqp.m) - sqp.setU.um;
end
end