function [obj,narargout] = objsqp(u,sqp,varargin)
% objective fucntion of the nonlinear programming problem in order to solve
% it using sqp
% 
% Rik Koch (TU Delft, 2021)

if (nargin > 2 && ~isempty(varargin{1}))
    yalmipsol = varargin{1};
else
    yalmipsol = 0;
end
obj = 0;
if (yalmipsol == 1)
    x = sdpvar(sqp.n,sqp.Nc);
else
    x = zeros(sqp.n,sqp.Nc);
end
for k = 1:sqp.Nc
    if (k > 1)
        x(:,k) = sqp.modelfun(x(:,k-1),u((k-1)*sqp.m+1:k*sqp.m));
    else
        x(:,k) = sqp.modelfun(sqp.x0,u((k-1)*sqp.m+1:k*sqp.m));
    end
    obj = obj + x(:,k)'*sqp.Q*x(:,k) + u((k-1)*sqp.m+1:k*sqp.m)'*sqp.R*u((k-1)*sqp.m+1:k*sqp.m);
end
if (yalmipsol == 1 && nargout > 1)
    narargout{1} = x;
end
end