function [Eps] = LFLDetEps(setP)
% Determines the conic partition of the set P (described in SetP)
% input:
% setP (A'*x <= 1)
% output:
% Eps (cell): all the conic partitions of the contractive set P
% 
% Rik Koch (TU Delft, 2021)

p = size(setP.A,2);
q = size(setP.v,2); % number of vertices of setP
n = size(setP.v,1); % number of states (dimension of vertices)
Eps = cell(p,1);
for i = 1:p
    Eps{i} = zeros(n,1);
    for k = 1:q
        if (min((setP.A(:,i) - setP.A)'*setP.v(:,k)) > -1e-6)
            Eps{i} = [Eps{i} setP.v(:,k)];
        end
    end
end
end